//
//  BFRecordScreenCameraManager.swift
//  BFRecordScreenKit
//
//  Created by 胡志强 on 2022/1/13.
//

import Foundation
import GPUImage
import BFCommonKit
import BFUIKit
import BFMediaKit


class BFRecordScreenCameraManager : BFRecordScreenBaseManager{

    //
    var rendView: BFRecordAvatarView = {
        let v = BFRecordAvatarView(frame: .zero, sessionPreset: AVCaptureSession.Preset.hd1920x1080, location: .backFacing)
        v.videoPixelsSize = Size(width: Float(cScreenWidth), height: Float(cScreenWidth) * 16.0 / 9.0)
        return v
    }()
    
    lazy var camera : GPUImageVideoCamera? = {
        let camera = GPUImageVideoCamera(sessionPreset: AVCaptureSession.Preset.hd1920x1080.rawValue, cameraPosition: AVCaptureDevice.Position.back)
        camera?.outputImageOrientation = UIInterfaceOrientation.portrait
        return camera
        
    }()
    
    lazy var movieWrite : GPUImageMovieWriter? = {
        let vpath = NSHomeDirectory() + "/camera_writer.mov"
        let writer = GPUImageMovieWriter(movieURL: URL(fileURLWithPath: vpath), size: CGSize(width: cScreenWidth, height: cScreenWidth * 16 / 9.0), fileType: ".mov", outputSettings: [:])
        filter.addTarget(writer)
        
        return writer
    }()
    
    override func resetEnv(){
//        guard let camera = camera else {
//            cShowHUB(superView: nil, msg: "摄像头开启失败！")
//            return
//        }
//        camera.startCapture()
//        camera.addTarget(filter)
//        filter.addTarget(pv)
        rendView.openCamera()
    }
    
    override func startRecord(){
//        guard let movieWrite = movieWrite else {
//            cShowHUB(superView: nil, msg: "录制启动失败")
//            return
//        }
//
//        movieWrite.startRecording()
        
        rendView.beginRecord(startTime: .zero)

    }
    
    override func endRecord(){
        let vpath = NSHomeDirectory() + "/camera_writer.mov"
        let newPath = PQBridgeObject.p_setupFileRename(vpath)
        
        rendView.endRecord()
    }
    
    override func clean() {
        super.clean()
    }
}
